\chapter{Simulation}
\label{chap:sim}
\section{Compiling the assembly files}
\begin{sloppypar}
	The compiler script and the assembly files are in the folder \emph{Src/compiler}. The test files can be found in \emph{Src/compiler/asm\_tests}. \emph{assembler.sh} has been modified to copy the result file in \emph{Src/DLX\_vhd/test\_bench\_and\_memory} where it will be used by the IRAM when the simulation is run. The assembly files are named in the form of \emph{testX\_<thing tested>.asm} and their order is from the oldest to the newest. \emph{test1.asm} is kind of a generic test with various instructions. Its aim is to test the instructions themselves, the behaviour of the pipeline and in general of the CPU but it does nothing useful. The other tests are for specific operations/situations and their names should be explanatory. To try out a file run, from folder \emph{compiler} \shellcmd{./assembler.sh asm\_tests/<test file>.asm} and proceed to the next step.
\end{sloppypar}

\section{Simulating with ModelSim}
\label{sec:simul}
The whole VHDL compilation, simulation, waveform definition have been scripted and all the related files are in \emph{Src/DLX\_vhd/test\_bench\_and\_memory}. The simulation script is \emph{simulate\_dlx.tcl} and should be run from the previous mentioned folder in vsim. No parameters are requested. For compiling the files some procedures are used and grouped in the file \emph{compile\_procedures.tcl}: they use the \textbf{glob} function to find the .vhd files. For reference in \autoref{lst:sim_proc} can be seen the procedure responsible of compiling the control unit. The script calls a \emph{wave\_dlx.do} file which defines the signals showed in the waveform. All external and internal signals are grouped following the various units hierarchy. In \autoref{fig:wave} can be seen the resulting screenshot after launching the script.

\inputtcl{test_bench_and_memory/compile_procedures.tcl}{29}{38}{0}{}{lst:sim_proc}
\inputfigure{waveform.png}{}{fig:wave}{0.45}

\section{Post-Synthesis simulation}
\label{sec:post_syn}
An attempt to try post-synthesis simulation has been made. The procedure is mostly equal to the one previous discussed but the script \emph{simulate\_dlx\_post\_syn.tcl} has to be run instead of \emph{simulate\_dlx.tcl}. Be sure to have previous synthesized the design in Synopsys and that the output files (VHDL and Verilog) are in the folder \emph{synthesis}. Both VHDL and Verilog files can be used. Uncomment only one of the two lines corresponding to the TOP level file to use in the script. See \autoref{lst:post_syn}. The settings for the simulation, like resolution, are the same as the behavioural one. In order to start the simulation a Verilog file describing the gates in the library has been added to the one provided. It can be found in \emph{synthesis/library} and has been downloaded from the NanGate site. The simulation starts but a lot of signals stay in unaffected and the whole procedure is quite "resources angry" and a lot slower than the behavioural one. No further attempts have been tried to make this simulation work and the files have been left there as reference. 

\inputtcl{test_bench_and_memory/simulate_dlx_post_syn.tcl}{17}{19}{0}{}{lst:post_syn}
